function [m1, m2] = fft_feature(ecg, fs)
%FFT_FEATURE

    ft = fft(ecg);
    %power spectrum
    p = abs(ft).^2;
    f = linspace(0,fs,length(ecg));
    freq = linspace(0,fs,9000);
    p2 = interp1(f, p, freq);
    
    p2 = p2/sum(p2);
    
    m1 = sum(p2((f > 2.5 & f < 4.5)'));
    m2 = sum(p2(f > 40 & f < 60));

end

