function features = moreSimpleFeaturesByJack(rr)

sd1 = sqrt(1/2*(std(rr(1:end-1)-rr(2:end)))^2);
sd2 = sqrt(abs(2*std(rr)^2-sd1^2));
%approximation of NN by RR 
pNN50 = sum(diff(rr)>50)/length(rr);
pNN100 = sum(diff(rr)>100)/length(rr);
pNN75 = sum(diff(rr)>75)/length(rr);
pNN38 = sum(diff(rr)>38)/length(rr);

features = [sd1 sd2 pNN50 pNN100 pNN75 pNN38];

end