function [noise,ecgcorrelation,QRS,ecgmean] = noiseDetector2(ecg, QRS, fs)

leftB= 90;
rightB = 180;

ecgmean = zeros(leftB+rightB,1);

for j=1:length(QRS)
   if(QRS(j)>leftB && QRS(j)<length(ecg)-rightB)
       
%        figure(2)
%        subplot(2,1,1)
%        plot(ecg(QRS(j)-leftB:QRS(j)+rightB-1))
       
           ecgmean(:,1) = ecgmean(:,1) + (ecg(QRS(j)-leftB:QRS(j)+rightB-1)-mean(ecg(QRS(j)-leftB:QRS(j)+rightB-1)))/std(ecg(QRS(j)-leftB:QRS(j)+rightB-1));

%        subplot(2,1,2)
%        plot(ecgmean);
       
   end
end

ecgmean=ecgmean./length(QRS);

ecgcorrelation=zeros(length(ecg),1);
ecgcorrelationPoint=zeros(length(QRS),1);
 

for j=1:length(QRS)
   if(QRS(j)>leftB && QRS(j)<length(ecg)-rightB)
       
       ecgtemp=ecg(QRS(j)-leftB+10:QRS(j)+rightB-1-10);
       ecgtemp = (ecgtemp-mean(ecgtemp))/std(ecgtemp);
       ecgmeanshort = ecgmean(10:end-11);
       ecgcorrelation(QRS(j)-leftB:QRS(j)+rightB-1) = ones(leftB+rightB,1)*dot(ecgtemp,ecgmeanshort);
       ecgcorrelationPoint(j)=dot(ecgtemp,ecgmeanshort);
%        ecgcorrelation2(QRS(j)-leftB:QRS(j)+rightB-1) = ones(leftB+rightB,1)*corr(ecgtemp,ecgmeanshort);

   end
end


% 
% clf
% figure(3)
% subplot(3,1,1)
% plot(ecg);
% subplot(3,1,2)
% plot(ecgcorrelation); 
% % plot(ecgcorrelation2*max(ecgcorrelation)); hold off;
% subplot(3,1,3)
% plot(ecgmean); 


    noiseCoeff=sum(ecgcorrelationPoint<50)/length(ecgcorrelationPoint);
    
    numberOfDetectedBeats = length(QRS);
    beatsDensity = numberOfDetectedBeats/(length(ecg)/fs);
    
%     amplitudeOfDetectedQRS = 2*std(ecg(QRS));
    amplitudeOfDetectedQRS = 2*std(ecg(QRS));
    
    %zero-crossing of difference rate
    DIFF=diff(ecg);
    ZCDR =  2*sum(DIFF(1:end-1)<0 & DIFF(2:end)>0)/length(DIFF);
    
%     if(length(ecg)>8000)
        
%         ecgcorrelationPointOneZero = find(ecgcorrelationPoint<50);
%         ecgcorrelationPointLargestSerie = max(diff([0 ; ecgcorrelationPointOneZero]));
%         noise = (noiseCoeff>0.50 || beatsDensity < 0.68 || amplitudeOfDetectedQRS>3.2 || ZCDR>0.29) & ecgcorrelationPointLargestSerie<10;
        
%     else    
        noise = noiseCoeff>0.50 || beatsDensity < 0.68 || amplitudeOfDetectedQRS>3.2 || ZCDR>0.29;
%     end